/*
* Politecnico di Milano
* Corso Informatica Medica 2012/2013 - Prof. Santambrogio
* Esercizi di: Alessandro A. Nacci
* Grazie a: Ing. Alessandra Bonetto - IEIM2012
* E-mail: alessandro.nacci@mail.polimi.it
* Web: www.alessandronacci.com
* ------------------------------------
*/


/**
*
*	DATI LANCIATI
*	---------------------------------	
* 	Calcolare media e mediana degli elementi di un array contenente i lanci di un dado. 
*	Calcolare inoltre le frequenze di ogni valore.
*/





#include <stdio.h>
#define N 11

void calcolaMedia(int array[], int *media);
void calcolaMediana(int array[], int *mediana);
void frequenze(int array[], int freq[]);
void swap(int *, int*);
void bubbleSort(int array[]);


int main(){
	
	int lanci[N]={3,4,6,1,3,5,4,2,6,2,3};

	//array contenente le frequenze dei valori da 0 a 5, rappresentanti i valori da 1 a 6 del dado
	int frequenze_array[6]={};				
	int i;


	//Stampa dei lanci
	for(i=0;i<N;i++)
	{
		printf("%d ", lanci[i]);
	}

	int media=0, mediana;
	calcolaMedia(lanci, &media);
	calcolaMediana(lanci, &mediana);
	frequenze(lanci, frequenze_array);

	printf("\nLa media e' %d\n", media);
	printf("La mediana e' %d\n", mediana);
	for(i=0;i<6;i++)
	{
		printf("La frequenza di %d e' %d\n", i+1, frequenze_array[i]);
	}

	return 0;

}

//Funzione che calcola il valore medio di un array
void calcolaMedia(int array[], int *media){
	int i;
	for(i=0;i<N;i++)
	{
		*media = *media + array[i];
	}
	
	*media = *media/N;
}


//Funzione che calcola la mediana di un array
void calcolaMediana(int array[], int *mediana){
	
	//Ordino l'array in ordine crescente
	bubbleSort(array);

	//Distinguo i due casi in cui l'array ha numero di elementi pari o dispari
	if(N%2!=0)
		*mediana = array[N/2+1];
	else
		*mediana = (array[N/2]+array[N/2+1])/2;

}

//Funzione che calcola le frequenze dei valori dei lanci
void frequenze(int array[], int freq[]){
	
	//Aggiungo +1 alla frequenza corrispondente 
	//all'elemento dell'array -1
	//Esempio: array[i]= 5, aggiungo +1 a freq[array[i]-1] 
	//cioe' freq[4] che rappresenta la frequenza di 5


	int i;

	for(i=0;i<N;i++)
		freq[array[i]-1]++;		
	
		
}

void bubbleSort(int arr[]){
	
	int i,j;

    for ( i = 1 ; i < N ; i++ )			
		for ( j = 0 ; j < N - i ; j++ )	
		{
                  if (arr[j] > arr[j + 1])		
                      swap(&arr[j], &arr[j+1]);	
            
      	}

}

void swap(int *a, int *b)
{
	int tmp;
	tmp = *a;
	*a = *b;
	*b = tmp;
}
